<?php
if(!isset($_SESSION)) 
{ 
session_start(); 
} 
if(!isset($_SESSION['is_login']) ){
header("location: login.php");
?>
<script>
window.location="login.php";
</script>
<?php
}

// $permission  = explode(',',$_SESSION['permission_id']);
// if(!in_array(19,$permission) && !in_array(1,$permission)  ){

// $op['is_success'] = false;
// $op['data'] 	  = "عذرا انت غير مخول للوصل الى هذه الصفحة";
// echo json_encode($op);
// exit;

// }

date_default_timezone_set($_SESSION['SYSTimezone']);

if (isset($_POST['type']) || isset($_GET['type'])){
		require("db_connect.php");

		if( isset($_GET['type']) && ($_GET['type'] == "load")){
			// DB table to use
			// show All products for specific category
			$cond = isset($_GET['id'])? ' AND IT.item_type_id='.$_GET['id']:'';
			$table  =  '(
				SELECT
					item_type_id,
					item_name,
					item_description,
					is_have_purchase,
					is_other,
					is_have_curtain
				FROM
					item_type IT
					
				WHERE
					( IT.is_deleted = 0 '.$cond.') 
			) AS ALLTBL';
			// Table's primary key
			//echo $table;
			$primaryKey = 'item_type_id';
			$columns = array(
			    array( 'db' => 'item_type_id', 'dt' => 0 ),

			    array( 'db' => 'item_name', 'dt' => 1 ),
			    array( 'db' => 'item_description', 'dt' => 2 ),
			    array( 'db' => 'is_have_purchase', 'dt' => 3 ),
			    array( 'db' => 'is_other', 'dt' => 4 ),
			    array( 'db' => 'is_have_curtain', 'dt' => 5 )
			    
			);
			// SQL server connection information
			$sql_details = array(
			    'user' => $mysql_user,
			    'pass' => $mysql_password,
			    'db'   => $mysql_db,
			    'host' => $mysql_server
			);
			require( 'ssp.php' );
			echo json_encode(
			    SSP::complex( $_GET, $sql_details, $table, $primaryKey, $columns ,null, '' )
			);
			exit;
		}

		if ($_POST['type']=="get") {

			//$user_id = $_POST['cusid'];

			$res = $db->query("SELECT *
				FROM item_type WHERE is_other =0 AND is_deleted = 0");
			if ($res) {
				//$row = $res->fetch_all();
				$op  = array();
				while ($row = $res->fetch_assoc()) {
				   
						$result[0]  = $row['item_type_id'];
						$result[1]  = $row['item_name'];
						$result[2]  = $row['is_have_purchase'];
						$result[3]  = $row['is_other'];
						$result[4]  = $row['is_have_curtain'];
						
						array_push($op,$result);
				}
				echo json_encode($op);
				exit;
			}else{
				echo 0;
				exit;
			}
		}

		if ($_POST['type']=="show_files") {

			$user_id = $_POST['obj_id'];

			$res = $db->query("SELECT * FROM product_image WHERE is_deleted=0 AND product_id_fk = '$user_id'");
			if ($res) {
				//$row = $res->fetch_all();
				$op  = array();
				while ($row = $res->fetch_assoc()) {
				    // do what you need.
						$result[0] = $row['image_path'];
						array_push($op,$result);
				}

				echo json_encode($op);
				exit;
			}else{
				echo 0;
				exit;
			}
		}

	

		if ($_POST['type'] == "update") {

			$id 						= $_POST['obj_id'];
			$item_name					=addslashes($_POST["item_name"]);
			$item_description			=addslashes($_POST["item_description"]);
			$is_have_purchase			=addslashes($_POST["is_have_purchase"]);
			$is_other				 	=addslashes($_POST["is_other"]);
			$is_have_curtain			=addslashes($_POST["is_have_curtain"]);
			
			$lastaction = "Update items";

			$op  = array('is_success'=>false, 'data' => '');

			

			$res = $db->query("SELECT * FROM item_type WHERE is_deleted=0 AND item_name = '$item_name' AND item_type_id != '$id'");
			if (mysqli_num_rows($res)>0) {
					$op['is_success'] = false;
					$op['data'] 	  = "خطأ الاسم مكرر";
					echo json_encode($op);
					exit;
			}

			
			// checking for changing item type
			$res1 = $db->query("SELECT * FROM item_type WHERE is_deleted=0  AND item_type_id = '$id'");

			$row = $res1->fetch_assoc();

			// check if changing is_other or is_have_purchase type 
			if($row['is_have_purchase'] != $is_have_purchase || $row['is_other'] != $is_other || $row['is_have_curtain'] != $is_have_curtain  ){

				// checking if this stock has rolls inside it and not finished yet
				$res2 = $db->query("SELECT * FROM sell_item WHERE is_deleted=0 AND item_type_id_fk = '$id'");

					if (mysqli_num_rows($res2)>0) {
						$op['is_success'] = false;
						$op['data'] 	  = "لا يمكن تغيير حالة الصنف لانه يحوي على مبيعات وستتأثر جداول المبيعات بهذا التغيير";
						echo json_encode($op);
						exit;
					}

					$update_qry = "UPDATE item_type SET  item_name = '$item_name', item_description='$item_description',is_have_purchase='$is_have_purchase',	is_other='$is_other',
										is_have_curtain='$is_have_curtain',last_action='$lastaction',last_action_by='".$_SESSION['user_id']."' WHERE item_type_id = $id";

						$res3 = $db->query($update_qry);

						if ($res3) {

								$op['is_success'] = true;
								$op['data'] 	  = "تمت عملية التحديث بنجاح";
								echo json_encode($op);
								exit;

						}else{
							$op['is_success'] = false;
							$op['data'] 	  	= "حصل خطأ لم تتم عملية التحديث بنجاح";
							echo json_encode($op);
							exit;
						}
			}
			

					


			$lastaction = "Update items";
			$update_qry = "UPDATE item_type SET  item_name = '$item_name', item_description='$item_description',last_action='$lastaction',last_action_by='".$_SESSION['user_id']."' WHERE item_type_id = $id";


			$res = $db->query($update_qry);
			if ($res) {
					$op['is_success'] = true;
					$op['data'] 	 	  = "تمت عملية التحديث بنجاح";
					echo json_encode($op);
					exit;
			}else{
				$op['is_success'] = false;
				$op['data'] 	  	= "حصل خطأ لم تتم عملية التحديث بنجاح";
				echo json_encode($op);
				exit;
			}
		}


		if ($_POST['type']=="delete") {

			$id=addslashes($_POST["obj_id"]);
			$reg_date = date("Y-m-d h:i:s", time());
			$lastaction = "Delete item_type";

			$op  = array('is_success'=>false, 'data' => '');

			$res = $db->query("SELECT count(*)  AS CNT FROM sell_item WHERE is_deleted=0 AND item_type_id_fk = '$id'");
			$row = $res->fetch_assoc();
			if ($row['CNT']>0) {
				$op['is_success'] = false;
				$op['data'] 	  = "لا يمكن حذف هذا الصنف فهو يحتوي على مبيعات";
				echo json_encode($op);
				exit;
			}


			$res1 = $db->query("SELECT count(*) AS CNT FROM product WHERE is_deleted=0 AND item_type_id_fk = '$id'");
			$row1 = $res1->fetch_assoc();

			if ($row1['CNT']>0) {
				$op['is_success'] = false;
				$op['data'] 	  = "لا يمكن حذف هذا الصنف لانه تم تعريف مواد تابعه له";
				echo json_encode($op);
				exit;
			}

			

			

  		$res = $db->query("UPDATE item_type SET is_deleted = 1 ,deleted_at = '$reg_date',last_action='$lastaction',last_action_by='".$_SESSION['user_id']."' WHERE item_type_id=$id");
    	if ($res){
        $op['is_success'] = true;
				$op['data'] 	  = "تمت عملية الحذف بنجاح";
				echo json_encode($op);
				exit;
     	}else{
      	$op['is_success'] = false;
				$op['data'] 	  = "حصل خطأ: الرجاء اعادة تحميل الصفحة والمحاولة من جديد";
				echo json_encode($op);
				exit;
     	}
		}

		if ($_POST['type'] == "create") {
      		$item_name					=addslashes($_POST["item_name"]);
			$item_description			=addslashes($_POST["item_description"]);
			$is_have_purchase			=addslashes($_POST["is_have_purchase"]);
			$is_other					=addslashes($_POST["is_other"]);
			$is_have_curtain			=addslashes($_POST["is_have_curtain"]);
			
			$res = $db->query("SELECT * FROM item_type WHERE is_deleted=0 AND item_name = '$item_name'");
			if (mysqli_num_rows($res)>0) {
					$op['is_success'] = false;
					$op['data'] 	  = "خطأ الاسم مكرر";
					echo json_encode($op);
					exit;
			}

			
				

				$reg_date = date("Y-m-d h:i:s", time());
				$lastaction = "Create New Items";

				$sql ="INSERT INTO item_type(item_name,item_description,is_have_purchase,is_other,is_have_curtain,created_by,last_action,last_action_by)
				VALUES('$item_name','$item_description','$is_have_purchase','$is_other','$is_have_curtain','".$_SESSION['user_id']."','$lastaction','".$_SESSION['user_id']."')";

				$res = $db->query($sql);

					if ($res) {

							$op['is_success'] = true;
							$op['data'] 	  = "تمت عملية الاضافة بنجاح";
							echo json_encode($op);
							exit;
					}
					else{
								$op['is_success'] = false;
								$op['data'] 	  = "حصل خطأ: الرجاء اعادة تحميل الصفحة والمحاولة من جديد";
								echo json_encode($op);
								exit;
					}
			

		}
	}
	else{
		header("Location:../");
		exit;
	}
?>
